<script lang="ts">
import VideoModal from '~/components/solutions/video-modal.vue';
import { UseLiteVimeo, UseLocalizedVideoSubtitles } from '~/mixins';

interface Card {
  title: string;
  iconName: string;
  description: string;
}

export default {
  components: {
    VideoModal,
  },
  mixins: [UseLiteVimeo, UseLocalizedVideoSubtitles],
  props: {
    card: {
      type: Array<Card>,
      required: true,
    },
    header: {
      type: String,
      required: true,
    },
    highlight: {
      type: Object,
      required: false,
      default: () => {},
    },
  },
  data: () => ({
    showModal: false,
  }),
  methods: {
    openModal() {
      this.showModal = true;
    },
  },
};
</script>

<template>
  <div class="slp-mt-96 why-container">
    <SlpRow class="container">
      <article v-if="highlight" class="highlight">
        <SlpColumn :cols="6" class="content">
          <div class="content__eyebrow">
            <img src="/nuxt-images/solutions/ai/icons/eyebrow-one.svg" alt="" />
            <SlpTypography variant="body2-bold" tag="span">
              {{ highlight.eyebrow }}
            </SlpTypography>
          </div>
          <div class="content__flex">
            <div class="content__header">
              <SlpTypography tag="h3" variant="heading4-bold">
                {{ highlight.header }}
              </SlpTypography>
              <img
                src="/nuxt-images/solutions/ai/icons/eyebrow-one.svg"
                alt=""
              />
            </div>

            <SlpTypography
              v-if="highlight.text"
              variant="body1"
              tag="div"
              class="content__text"
            >
              <div v-html="$md.render(highlight.text)" />
            </SlpTypography>

            <SlpButton
              variant="tertiary"
              :href="highlight.cta.url"
              :data-ga-name="highlight.cta.dataGaName"
              :data-ga-location="highlight.cta.dataGaLocation"
            >
              {{ highlight.cta.text }}
              <SlpIcon
                name="chevron-lg-right"
                variant="product"
                class="play-icon"
              />
            </SlpButton>
          </div>
        </SlpColumn>
        <div class="media-container" @click="openModal()">
          <SlpIcon
            class="play-icon"
            name="play-circle"
            variant="marketing"
            size="xl"
          />
          <img :src="highlight.video_thumbnail" />
        </div>
      </article>
      <VideoModal
        v-show="showModal && highlight?.video_src"
        light-background
        :visible="showModal"
        @close="showModal = false"
      >
        <template #body>
          <lite-vimeo
            :videoid="getVimeoVideoId(createVideoSource(highlight?.video_src))"
            autoplay
          ></lite-vimeo>
        </template>
      </VideoModal>
    </SlpRow>
  </div>
</template>

<style lang="scss" scoped>
.why-container {
  margin-bottom: $spacing-96;
  color: $color-text-50;
}

.container {
  gap: 44px;
}

.highlight {
  position: relative;
  flex: 1 0 100%;
  background: linear-gradient(
    0.71deg,
    rgba(225, 152, 109, 0.1) 0.61%,
    rgba(110, 67, 211, 0.1) 99.4%
  );
  border: 1px solid $color-surface-600;
  border-radius: 8px;
  display: flex;

  @media (max-width: $breakpoint-md) {
    flex-direction: column-reverse;
  }

  .content {
    padding: 32px;
    flex: 0 0 60%;

    &__eyebrow,
    &__header,
    .slp-btn {
      color: $color-surface-50;
    }

    &__header {
      display: flex;
      gap: 8px;

      img {
        padding-bottom: 8px;
      }

      @media (max-width: $breakpoint-md) {
        h3 {
          flex: 0 0 70%;
        }
      }
    }

    &__eyebrow {
      margin-bottom: 16px;
      position: relative;
      padding: 4px 12px;
      display: inline-flex;
      align-items: center;

      img {
        width: 20px;
        height: 20px;
        margin-right: 5px;
      }

      &:before {
        content: '';
        position: absolute;
        top: 0;
        right: 0;
        bottom: 0;
        left: 0;
        border-radius: 20px;
        border: 1.5px solid transparent;
        background: linear-gradient(
            89.09deg,
            #e1986d -1.12%,
            #7759c2 102.06%,
            #6e43d3 102.07%
          )
          border-box;
        -webkit-mask:
          linear-gradient(#fff 0, #fff 0) padding-box,
          linear-gradient(#fff 0, #fff 0);
        -webkit-mask:
          linear-gradient(#fff 0 0) padding-box,
          linear-gradient(#fff 0 0);
        -webkit-mask-composite: xor;
        mask-composite: exclude;
      }
    }

    &__flex {
      display: flex;
      flex-direction: column;
      justify-content: space-between;
      gap: 24px;
    }

    &__text {
      margin-bottom: 24px;
      color: #a2a1a6 !important;
    }
  }

  .media-container {
    width: 100%;
    position: relative;

    @media (max-width: $breakpoint-md) {
      flex: 0 0 0;
    }

    img {
      width: 100%;
      height: 100%;
      display: block;
      cursor: pointer;
      object-fit: cover;
      object-position: center;
      border-radius: 0 8px 8px 0;

      @media (max-width: $breakpoint-md) {
        border-radius: 8px 8px 0 0;
      }
    }

    .play-icon {
      position: absolute;
      top: 50%;
      left: 50%;
      transform: translate(-50%, -50%);
      font-size: 48px;
      color: #171321;
      cursor: pointer;
      z-index: 2;

      ::v-deep path {
        fill: #fff;
        transition: fill 0.2s ease;
      }

      ::v-deep circle {
        transition: fill 0.2s ease;
      }
    }
  }
}
</style>
